﻿﻿var appVersion = "5.0";
var link = 'http://192.168.8.1/';
var is4G = false;
var rscp = 0;

var lte_band_1 = 0x1;
var lte_band_2 = 0x2;
var lte_band_3 = 0x4;
var lte_band_4 = 0x8;
var lte_band_5 = 0x10;
var lte_band_7 = 0x40;
var lte_band_8 = 0x80;
var lte_band_20 = 0x80000;
var lte_band_32 = 0x80000000;
var lte_band_28 = 0x8000000;
var lte_band_38 = 0x2000000000;
var lte_band_40 = 0x8000000000;
var lte_band_41 = 0x10000000000;
var lte_band_42 = 0x20000000000;
var lte_band_all = 0x1A08A0C00DF;
var g_lte_bands = 0;
var g_net_mode = 0;

//init(link,'',admin,pass,1);
function Main() {
syncDeviceStatus();
readBack();
}

//init(link,'',admin,pass,1);
function Main() {
status();
signal();
getDeviceInfo();
signalpara();
plmn();
netmode();
traffic();
}


function traffic() {
$.get(link + 'api/monitoring/traffic-statistics', function (data) { //api/device/signal
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);
$('#time').html(getTime($xml.find('CurrentConnectTime').text()));
$('#CurrentDownloadRate').html(dataCon($xml.find('CurrentDownloadRate').text(), 0) + " KB/s");
$('#CurrentUploadRate').html(dataCon($xml.find('CurrentUploadRate').text(), 0) + " KB/s");
$('#CurrentDownload').html(dataCon($xml.find('CurrentDownload').text(), 1) + " MB");
$('#CurrentUpload').html(dataCon($xml.find('CurrentUpload').text(), 1) + " MB");
var up = $xml.find('TotalUpload').text() * 1;
var down = $xml.find('TotalDownload').text() * 1;
$('#updown').html(dataCon(up + down, 2) + " GB");
setTimeout(Main, 100);
});
}



function signal() {
$.ajax({
url: link + 'api/device/signal',
headers : {
"__RequestVerificationToken" : Token //,
//"Cookie" : Season
},
success: function (data) {
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);

$('#pcival').html(($xml.find('pci').text() == "" ? $xml.find('sc').text() : $xml.find('pci').text()));
$('#cidval').html($xml.find('cell_id'));
if($xml.find('rssi').text() == ""){
$('#rssi').hide();
$('#pcival').hide();                 
$('#cidval').hide();
$('#pcin').show();
$('#cidn').show();
}else{
$('#pcin').hide();
$('#cidn').hide();
$('#cidval').show();
$('#pcival').show();
$('#rssi').show();}
if($xml.find('rsrp').text() == ""){
$('#rsrqtr').hide();
$('#rsrqtr2').hide();
$('#rsrqtr3').hide();
$('#bw').hide();
}else{
$('#rsrqtr').show();
$('#rsrqtr2').show();
$('#rsrqtr3').show();
$('#bw').show();
//Create graphical
var rsrpDbm=$xml.find('rsrp').text();
rsrpDbm=parseInt(rsrpDbm.substring(0,rsrpDbm.length-3));

var rsrqDbm=$xml.find('rsrq').text();
rsrqDbm=parseInt(rsrqDbm.substring(0,rsrqDbm.length-2));

var sinrDbm=$xml.find('sinr').text();
//if sinr more than 30db
if (sinrDbm == ">=30db")
{
sinrDbm="30";
sinrDbm=parseInt(sinrDbm);
}
else{
sinrDbm=parseInt(sinrDbm.substring(0,sinrDbm.length-2));
}

var rsrpPercen=140+rsrpDbm;
rsrpPercen=rsrpPercen/70*100;
var rsrpPercenW  =rsrpPercen.toString();
rsrpPercenW=rsrpPercenW + "%";
//rsrpPercen=Math.abs(rsrpPercen);

var rsrpStr="";
if (rsrpDbm <= -120) {
rsrpStr="Weak";
$('#rsrpreading').css("background-color","#A21206");
} else if (rsrpDbm <= -90) {
rsrpStr="Medium";
$('#rsrpreading').css("background-color","#CB7F00");
} else if (rsrpDbm <= -80) {
rsrpStr="Good";
$('#rsrpreading').css("background-color","#06A21E");
} else {
rsrpStr="Excellent";
$('#rsrpreading').css("background-color","#06A21E");
}

var rsrqPercen=20+rsrqDbm;
rsrqPercen=rsrqPercen/20*100;
var rsrqPercenW=rsrqPercen.toString();
rsrqPercenW=rsrqPercenW + "%";

var rsrqStr="";
if (rsrqDbm <= -20) {
rsrqStr="Weak";
$('#rsrqreading').css("background-color","#A21206");
} else if (rsrqDbm <= -10) {
rsrqStr="Medium";
$('#rsrqreading').css("background-color","#CB7F00");
} else if (rsrqDbm <= -5) {
rsrqStr="Good";
$('#rsrqreading').css("background-color","#06A21E");
} else {
rsrqStr="Excellent";
$('#rsrqreading').css("background-color","#06A21E");
}

var sinrPercen=sinrDbm;
sinrPercen=sinrPercen/30*100;
var sinrPercenW=sinrPercen.toString();
sinrPercenW=sinrPercenW + "%";

var sinrStr="";
if (sinrDbm <= 5) {
sinrStr="Weak";
$('#sinrreading').css("background-color","#A21206");
} else if (sinrDbm <= 15) {
sinrStr="Medium";
$('#sinrreading').css("background-color","#CB7F00");
} else if (sinrDbm <= 25) {
sinrStr="Good";
$('#sinrreading').css("background-color","#06A21E");
} else {
sinrStr="Excellent";
$('#sinrreading').css("background-color","#06A21E");
}

$('#rsrp').html(rsrpDbm + "dB");
$('#rsrq').html(rsrqDbm + "dB");
$('#sinr').html(sinrDbm + "dB");



$('#rsrpreading').css("width",rsrpPercenW);
$('#rsrqreading').css("width",rsrqPercenW);
$('#sinrreading').css("width",sinrPercenW);


$('#rsrpIndicator').html(rsrpStr);
$('#rsrqIndicator').html(rsrqStr);
$('#sinrIndicator').html(sinrStr);

//$('#rsrp').html($xml.find('rsrp').text());
}
$('#rssi').html($xml.find('rssi').text());
$('#enodeb_id').html($xml.find('enodeb_id').text());
$('#tac').html($xml.find('tac').text());
$('#dlbandwidth').html($xml.find('dlbandwidth').text());
$('#dlfrequency').html($xml.find('dlfrequency').text());
$('#ulfrequency').html($xml.find('ulfrequency').text());
$('#dl_mcs').html($xml.find('dl_mcs').text());
$('#ul_mcs').html($xml.find('ul_mcs').text());
$('#earfcn').html($xml.find('earfcn').text());
$('#txpower').html($xml.find('txpower').text());
$('#nrrsrp').html($xml.find('nrrsrp').text());
$('#nrrsrq').html($xml.find('nrrsrq').text());
$('#nrsinr').html($xml.find('nrsinr').text());
$('#nrdlbandwidth').html($xml.find('nrdlbandwidth').text());
$('#nrdlfreq').html($xml.find('nrdlfreq').text());
$('#nrulfreq').html($xml.find('nrulfreq').text());
$('#nrdlmcs').html($xml.find('nrdlmcs').text());
$('#nrulmcs').html($xml.find('nrulmcs').text());
$('#nrearfcn').html($xml.find('nrearfcn').text());
$('#nrtxpower').html($xml.find('nrtxpower').text());
$('#rrc_status').html($xml.find('rrc_status').text());
$('#cqi0').html($xml.find('cqi0').text());
$('#cqi1').html($xml.find('cqi1').text());
$('#tdd').html($xml.find('tdd').text());
$('#transmode').html($xml.find('transmode').text());
if($xml.find('nei_cellid').text() == ""){	
$('#nei_cellidtr').show();
}else{
$('#nei_cellidtr').show();
$('#nei_cellid').html($xml.find('nei_cellid').text());
}
if($xml.find('Rscp').text() != ""){
$('#rscp').html($xml.find('Rscp').text());
rscp = 1;
}

// if need login
if ($xml.find('code').text() != "") {
//init(link,"",admin,pass,true);
}
}
});
}

function signalpara() {
$.get(link + 'api/net/signal-para', function (data) {
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);
if(rscp == 0){$('#rscp').html($xml.find('Rscp').text());rscp = 0;}
$('#ecio').html($xml.find('Ecio').text());
});
}

function status() {
$.get(link + 'api/monitoring/status', function (data) {
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);
$('#conn').html(conMod($xml.find('ConnectionStatus').text()));
$('#signal')[0].src = "signal0" + $xml.find('SignalIcon').text() + ".png";
$('#RoamingStatus').html(($xml.find('RoamingStatus').text() == 0 ? "No" : "Yes"));
($xml.find('BatteryStatus').text() == 0 ? $('#charging').hide() : $('#charging').show());


if($xml.find('ip').text() == ""){

$('#wanip').show();
$('#noip').hide();
}else{
$('#noip').hide();
$('#ip').show();
}
if($xml.find('ConnectionStatus').text() != "901"){
$('#ip').hide();
$('#wanip').hide();
$('#noip').show();
}else{
$('#ip').show();
$('#wanip').show();
$('#noip').hide();
}
if($xml.find('CurrentNetworkTypeEx').text() == ""){
$('#netmode').hide();
$('#band').hide();
$('#nonw').show();


}else{
$('#netmode').show();
$('#band').show();
$('#nonw').hide();

}



$('#ip').html($xml.find('WanIPAddress').text());

$('#WifiUsers').html($xml.find('CurrentWifiUser').text());
$('#WifiUsers').html($xml.find('CurrentWifiUser').text()); //netType
$('#mode').html(netType($xml.find('CurrentNetworkTypeEx').text())); 
$('#mode2').html(netType($xml.find('CurrentNetworkTypeEx').text())); //" - " + 
// check error
if ($xml.find('code').text() != "") {
$("#frame").attr('src', link + 'html/home.html');
}
});
}
function getDeviceInfo() {
$.get(link + 'api/device/information', function (data) {
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);
$('#modemmodel').html(conMod($xml.find('DeviceName').text()));
$('#wanip').html($xml.find('WanIPAddress').text());

$('#imei').html(conMod($xml.find('Imei').text()));
$('#imsi').html(conMod($xml.find('Imsi').text()));
$('#serial').html(conMod($xml.find('Serial').text()));
$('#number').html(conMod($xml.find('Msisdn').text()));
$('#hardware').html(conMod($xml.find('HardwareVersion').text()));
$('#software').html(conMod($xml.find('SoftwareVersion').text()));
$('#webui').html(conMod($xml.find('WebUIVersion').text()));
$('#mac1').html(conMod($xml.find('MacAddress1').text()));
$('#mac2').html(conMod($xml.find('MacAddress2').text()));
$('#productfam').html(conMod($xml.find('ProductFamily').text()));
$('#classify').html(conMod($xml.find('Classify').text()));
});
}

function plmn() {
$.get(link + 'api/net/current-plmn', function (data) {
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);
if($xml.find('brand').text() == ""){
$('#brand').html($xml.find('ShortName').text());
}else{
$('#brand').html($xml.find('FullName').text());}
$('#netmode').html(netMod($xml.find('Rat').text()));
});
}

function netmode() {
$.get(link + 'api/net/net-mode', function (data) {
var xml = data,
xmlDoc = $.parseXML(xml),
$xml = $(xmlDoc);
$('#band2').html(_4GType($xml.find('LTEBand').text()));
$('#band').html(_4GType($xml.find('LTEBand').text()));
});
}

function set2G(){
refresh('01','3FFFFFFF','7FFFFFFFFFFFFFFF');
}
function set3G(){
refresh('02','3FFFFFFF','7FFFFFFFFFFFFFFF');
}
function set4G(){
refresh('03','3FFFFFFF','7FFFFFFFFFFFFFFF');
}

function refresh(val,val2,val3){
$.ajax({
url : link + 'api/net/net-mode',
type : 'post',
data : '<?xml version="1.0" encoding="UTF-8"?><response><NetworkMode>'+val+'</NetworkMode><NetworkBand>'+val2+'</NetworkBand><LTEBand>'+val3+'</LTEBand></response>',
headers : {
"__RequestVerificationToken" : Token
},
dataType : 'xml',
success : function (data, textStatus, request) {
$('.btn').prop("disabled",false);
getTok();
var res = data;
if (data.firstChild.textContent == "OK") {
msg("Succeeded");
} else {
msg("Failure");
}
},
error : function (request, textStatus, errorThrown) {
$('.btn').prop("disabled",false);
msg("Request error");
getTok();
}
});
}
function conMod(mode) {
switch (mode) {
case "900":
return "Trying to connect";
break;
case "901":
return "Connected";
break;
case "902":
return "not connected";
break;
case "903":
return "Disconnect";
break;
case "905":
return "no service";
break;
case "906":
return "Error";
break;
case "33":
return "Unable to connect";
break;
default:
return mode;
}
}
function netMod(mode) {
is4G = false;
switch (mode) {
case "0":
return "2G";
break;
case "2":
return "3G";
break;
case "5":
return "HSPA+";
break;
case "7":
is4G = true;
return "4G";
break;
default:
return mode;
}
}
function getTime(totalSeconds) {
var hours = Math.floor(totalSeconds / 3600);
totalSeconds %= 3600;
var minutes = Math.floor(totalSeconds / 60);
var seconds = totalSeconds % 60;
if (minutes < 10) {minutes = "0"+minutes;}
if (seconds < 10) {seconds = "0"+seconds;}
return hours + ":" + minutes + ":" + seconds;
}
function netType(value) {
is4G = false;
var arr1 = ["No service","GSM","GPRS","EDGE","WCDMA","HSDPA","HSUPA","HSPA","TDSCDMA","HSPA +","EVDO rev. 0","EVDO rev. And","EVDO rev. B","1xRTT","UMB","1xEVDV","3xRTT","HSPA + 64QAM","HSPA + MIMO","LTE","IS95","IS95B","CDMA1X","EVDO rev. 0","EVDO rev. And","EVDO rev. B","Hybrid CDMA1X","Hybrid EVDO rev. 0","Hybrid EVDO rev. And","Hybrid EVDO rev. B","EHRPD rev. 0","EHRPD rev. And","EHRPD rev. B","The hybrid EHRPD rev. 0","The hybrid EHRPD rev. And","The hybrid EHRPD rev. B"]
var arr2 = ["WCDMA","HSDPA","HSUPA","HSPA","HSPA +","DC HSPA +"]
if(value == 81){
return "802.16";
}else if(value == 101){
is4G = true;
return "4G";
}else if(value == 1011){
is4G = true;
return "4G+";
}else if(value<37){
return " " + arr1[value];
}else if(value<47 && value>40){
return " " + arr2[value - 41];
}else if(value<66 && value>60){
return " " + arr2[value - 61];
}else{
return " " + value;
}
return " ";
}

function _4GType(value) {
if(is4G == false){
return " ";
}

var lteBand = " ";
var lbm = parseInt(value, 16);
if (BitwiseAndLarge(lbm, lte_band_all) == lte_band_all) {
lteBand = lteBand + lbm.toString(16).toUpperCase();
} else {
if ((lbm & lte_band_28) != 0) {
lteBand = lteBand + "FDD 700" + "+";
}
if ((lbm & lte_band_20) != 0) {
lteBand = lteBand + "FDD 800" + "+";
}
if ((lbm & lte_band_5) != 0) {
lteBand = lteBand + "FDD 850" + "+";
}
if ((lbm & lte_band_8) != 0) {
lteBand = lteBand + "FDD 900" + "+";
}
if ((lbm & lte_band_32) != 0) {
lteBand = lteBand + "FDD 1500" + "+";
}
if ((lbm & lte_band_4) != 0) {
lteBand = lteBand + "FDD 1700" + "+";
}
if ((lbm & lte_band_3) != 0) {
lteBand = lteBand + "FDD 1800" + "+";
}
if ((lbm & lte_band_2) != 0) {
lteBand = lteBand + "FDD 1900" + "+";
}
if ((lbm & lte_band_1) != 0) {
lteBand = lteBand + "FDD 2100" + "+";
}
if ((lbm & lte_band_7) != 0) {
lteBand = lteBand + "FDD 2600" + "+";
}
if (BitwiseAndLarge(lbm, lte_band_40) != 0) {
lteBand = lteBand + "TDD 2300" + "+";
}
if (BitwiseAndLarge(lbm, lte_band_41) != 0) {
lteBand = lteBand + "TDD 2500" + "+";
}
if (BitwiseAndLarge(lbm, lte_band_38) != 0) {
lteBand = lteBand + "TDD 2600" + "+";
}
if (BitwiseAndLarge(lbm, lte_band_42) != 0) {
lteBand = lteBand + "TDD 3500" + "+";
}
}
if (lteBand.substring(lteBand.length - 1, lteBand.length) == "+") {
lteBand = lteBand.substring(0, lteBand.length - 1);
}
return lteBand;
}

function dataCon(bytes, unit) {
if (bytes > -1) {
var unites = [1024, 1048576, 1073741824]; //KB,MB,GB
bytes = bytes / unites[unit];
return bytes.toFixed(2);
} else {
return 0;
}
}
function showSlider() {
$('.slide')[0].style.left = '0px';
$('.slider')[0].style.width = '100%';
var newData = B4A.CallSub('isVisible', true, "true");
}
function hideSlider() {
$('.slide')[0].style.left = '-250px';
$('.slider')[0].style.width = '0px';
var newData = B4A.CallSub('isVisible', true, "false");
}
function toggleLight() {
$('body').toggleClass('darkBody');
$('.label').toggleClass('darkLabel');
var newData = B4A.CallSub('isDark', true, $('body').attr('class'));
}
function openPage(url, name) {
var newData = B4A.CallSub('openPage', true, url, name);
}
function showInfo(ver) {
var newData = B4A.CallSub('showInfo', true, ver);
}
$(document).ready(function(){
$("input[name='LTE_Band']").click(function() {
if ($('#LTE_ALL').get(0).checked) {
g_lte_bands = "7FFFFFFFFFFFFFFF";
$('#LTE_B1').attr('disabled','disabled');
$('#LTE_B2').attr('disabled','disabled');
$('#LTE_B3').attr('disabled','disabled');
$('#LTE_B4').attr('disabled','disabled');
$('#LTE_B5').attr('disabled','disabled');
$('#LTE_B7').attr('disabled','disabled');
$('#LTE_B8').attr('disabled','disabled');
$('#LTE_B20').attr('disabled','disabled');
$('#LTE_B28').attr('disabled','disabled');
$('#LTE_B32').attr('disabled','disabled');
$('#LTE_B38').attr('disabled','disabled');
$('#LTE_B40').attr('disabled','disabled');
$('#LTE_B41').attr('disabled','disabled');
$('#LTE_B42').attr('disabled','disabled');
$('#LTE_B1').get(0).checked = false;
$('#LTE_B2').get(0).checked = false;
$('#LTE_B3').get(0).checked = false;
$('#LTE_B4').get(0).checked = false;
$('#LTE_B5').get(0).checked = false;
$('#LTE_B7').get(0).checked = false;
$('#LTE_B8').get(0).checked = false;
$('#LTE_B20').get(0).checked = false;
$('#LTE_B28').get(0).checked = false;
$('#LTE_B32').get(0).checked = false;
$('#LTE_B38').get(0).checked = false;
$('#LTE_B40').get(0).checked = false;
$('#LTE_B41').get(0).checked = false;
$('#LTE_B42').get(0).checked = false;
}
else {
var lbm = 0;
$('#LTE_ALL').get(0).checked = false;
if ($('#LTE_B1').get(0).checked)
lbm += lte_band_1;
if ($('#LTE_B2').get(0).checked)
lbm += lte_band_2;
if ($('#LTE_B3').get(0).checked)
lbm += lte_band_3;
if ($('#LTE_B4').get(0).checked)
lbm += lte_band_4;
if ($('#LTE_B5').get(0).checked)
lbm += lte_band_5;
if ($('#LTE_B7').get(0).checked)
lbm += lte_band_7;
if ($('#LTE_B8').get(0).checked)
lbm += lte_band_8;
if ($('#LTE_B20').get(0).checked)
lbm += lte_band_20;
if ($('#LTE_B28').get(0).checked)
lbm += lte_band_28;
if ($('#LTE_B32').get(0).checked)
lbm += lte_band_32;
if ($('#LTE_B38').get(0).checked)
lbm += lte_band_38;
if ($('#LTE_B40').get(0).checked)
lbm += lte_band_40;
if ($('#LTE_B41').get(0).checked)
lbm += lte_band_41;
if ($('#LTE_B42').get(0).checked)
lbm += lte_band_42;
g_lte_bands = lbm.toString(16).toUpperCase();
$('#LTE_B1').removeAttr('disabled');
$('#LTE_B2').removeAttr('disabled');
$('#LTE_B3').removeAttr('disabled');
$('#LTE_B4').removeAttr('disabled');
$('#LTE_B5').removeAttr('disabled');
$('#LTE_B7').removeAttr('disabled');
$('#LTE_B8').removeAttr('disabled');
$('#LTE_B20').removeAttr('disabled');
$('#LTE_B28').removeAttr('disabled');
$('#LTE_B32').removeAttr('disabled');
$('#LTE_B38').removeAttr('disabled');
$('#LTE_B40').removeAttr('disabled');
$('#LTE_B41').removeAttr('disabled');
$('#LTE_B42').removeAttr('disabled');
}
});

$("input[name='net_mode']").click(function() {
var net_mode = '00';
if ($('#NET_AUTO').get(0).checked) {
net_mode = '00';
g_lte_bands = '7FFFFFFFFFFFFFFF';
} else if ($('#NET_2G').get(0).checked) {
net_mode = '01';
g_lte_bands = '7FFFFFFFFFFFFFFF';
} else if ($('#NET_3G').get(0).checked) {
net_mode = '02';
g_lte_bands = '7FFFFFFFFFFFFFFF';
} else if ($('#NET_4G').get(0).checked) {
net_mode = '03';
}
g_net_mode = net_mode.toString();
});

$('#btnApply').click(function() {
refresh(g_net_mode,'3FFFFFFF',g_lte_bands);
});
});

function initNetworkMode(value) {
var net_mode = parseInt(value, 10)
switch (value) {
case 1:
$('#NET_AUTO').get(0).checked = false;
$('#NET_2G').get(1).checked = true;
$('#NET_3G').get(0).checked = false;
$('#NET_4G').get(0).checked = false;
break;
case 2:
$('#NET_AUTO').get(0).checked = false;
$('#NET_2G').get(0).checked = false;
$('#NET_3G').get(1).checked = true;
$('#NET_4G').get(0).checked = false;
break;
case 3:
$('#NET_AUTO').get(0).checked = false;
$('#NET_2G').get(0).checked = false;
$('#NET_3G').get(0).checked = false;
$('#NET_4G').get(1).checked = true;
break;
default:
$('#NET_AUTO').get(1).checked = true;
$('#NET_2G').get(0).checked = false;
$('#NET_3G').get(0).checked = false;
$('#NET_4G').get(0).checked = false;
break;
}

}

function initBandSel(value) {
var lbm = parseInt(value, 16);
if (BitwiseAndLarge(lbm, lte_band_all) == lte_band_all) {
$('#LTE_ALL').get(0).checked = true;
$('#LTE_B1').get(0).checked = false;
$('#LTE_B2').get(0).checked = false;
$('#LTE_B3').get(0).checked = false;
$('#LTE_B4').get(0).checked = false;
$('#LTE_B5').get(0).checked = false;
$('#LTE_B7').get(0).checked = false;
$('#LTE_B8').get(0).checked = false;
$('#LTE_B20').get(0).checked = false;
$('#LTE_B28').get(0).checked = false;
$('#LTE_B32').get(0).checked = false;
$('#LTE_B38').get(0).checked = false;
$('#LTE_B40').get(0).checked = false;
$('#LTE_B41').get(0).checked = false;
$('#LTE_B42').get(0).checked = false;
$('#LTE_B1').attr('disabled','disabled');
$('#LTE_B2').attr('disabled','disabled');
$('#LTE_B3').attr('disabled','disabled');
$('#LTE_B4').attr('disabled','disabled');
$('#LTE_B5').attr('disabled','disabled');
$('#LTE_B7').attr('disabled','disabled');
$('#LTE_B8').attr('disabled','disabled');
$('#LTE_B20').attr('disabled','disabled');
$('#LTE_B28').attr('disabled','disabled');
$('#LTE_B32').attr('disabled','disabled');
$('#LTE_B38').attr('disabled','disabled');
$('#LTE_B40').attr('disabled','disabled');
$('#LTE_B41').attr('disabled','disabled');
$('#LTE_B42').attr('disabled','disabled');
}
else {
$('#LTE_ALL').get(0).checked = false;
$('#LTE_B1').get(0).checked = (lbm & lte_band_1) != 0;
$('#LTE_B2').get(0).checked = (lbm & lte_band_2) != 0;
$('#LTE_B3').get(0).checked = (lbm & lte_band_3) != 0;
$('#LTE_B4').get(0).checked = (lbm & lte_band_4) != 0;
$('#LTE_B5').get(0).checked = (lbm & lte_band_5) != 0;
$('#LTE_B7').get(0).checked = (lbm & lte_band_7) != 0;
$('#LTE_B8').get(0).checked = (lbm & lte_band_8) != 0;
$('#LTE_B20').get(0).checked = (lbm & lte_band_20) != 0;
$('#LTE_B28').get(0).checked = (lbm & lte_band_28) != 0;
$('#LTE_B32').get(0).checked = (lbm & lte_band_32) != 0;
$('#LTE_B38').get(0).checked = BitwiseAndLarge(lbm, lte_band_38) != 0;
$('#LTE_B40').get(0).checked = BitwiseAndLarge(lbm, lte_band_40) != 0;
$('#LTE_B41').get(0).checked = BitwiseAndLarge(lbm, lte_band_41) != 0;
$('#LTE_B42').get(0).checked = BitwiseAndLarge(lbm, lte_band_42) != 0;
$('#LTE_B1').removeAttr('disabled');
$('#LTE_B2').removeAttr('disabled');
$('#LTE_B3').removeAttr('disabled');
$('#LTE_B4').removeAttr('disabled');
$('#LTE_B5').removeAttr('disabled');
$('#LTE_B7').removeAttr('disabled');
$('#LTE_B8').removeAttr('disabled');
$('#LTE_B20').removeAttr('disabled');
$('#LTE_B28').removeAttr('disabled');
$('#LTE_B32').removeAttr('disabled');
$('#LTE_B38').removeAttr('disabled');
$('#LTE_B40').removeAttr('disabled');
$('#LTE_B41').removeAttr('disabled');
$('#LTE_B42').removeAttr('disabled');
}
}

function BitwiseAndLarge(val1, val2) {
var shift = 0, result = 0;
var mask = ~((~0) << 30);
var divisor = 1 << 30;
while ((val1 != 0) && (val2 != 0)) {
var rs = (mask & val1) & (mask & val2);
val1 = Math.floor(val1 / divisor);
val2 = Math.floor(val2 / divisor);
var i = shift++;
for (i; i--;) {
rs *= divisor;
}
result += rs;
}
return result;
}
function getBandString(band) {
var bandstr = '';
if (band == 0x3FFFFFFF) {
bandstr = Label_CM_BAND_PREF_ANY;
}
else if (band == 0x680380) {
bandstr = common_auto;
} else {
jQuery.each(g_arrNetworkBand, function (i, n) {
if (BitwiseAndLarge(n[0], band) > 0) {
if (bandstr.length > 0) {
bandstr += '/';
}
bandstr += n[1];
}
});
}
return bandstr;
}
